import { Border } from './Border';
import { BorderStyle } from './BorderStyle';
import { Color } from './Color';
import { HorizontalAlignment } from './HorizontalAlignment';
import { HorizontalAlignmentLastLine } from './HorizontalAlignmentLastLine';
import { IParagraphProperties } from './IParagraphProperties';
import { PageBreak } from './PageBreak';
import { TabStopType } from './TabStopType';
import { TabStop } from './TabStop';
import { VerticalAlignment } from './VerticalAlignment';
export declare class ParagraphProperties implements IParagraphProperties {
    private backgroundColor;
    private borderBottom;
    private borderLeft;
    private borderRight;
    private borderTop;
    private horizontalAlignment;
    private horizontalAlignmentLastLine;
    private lineHeight;
    private lineSpacing;
    private marginBottom;
    private marginLeft;
    private marginRight;
    private marginTop;
    private minimumLineHeight;
    private orphans;
    private paddingBottom;
    private paddingLeft;
    private paddingRight;
    private paddingTop;
    private pageBreak;
    private shouldKeepTogether;
    private shouldKeepWithNext;
    private textIndent;
    private verticalAlignment;
    private widows;
    private tabStops;
    constructor();
    /** @inheritdoc */
    setBackgroundColor(color: Color | undefined): void;
    /** @inheritdoc */
    getBackgroundColor(): Color | undefined;
    /** @inheritdoc */
    setBorder(width: number, style: BorderStyle, color: Color): void;
    /** @inheritdoc */
    removeBorder(): void;
    /** @inheritdoc */
    setBorderBottom(width: number, style: BorderStyle, color: Color): void;
    /** @inheritdoc */
    getBorderBottom(): Border | undefined;
    /** @inheritdoc */
    removeBorderBottom(): void;
    /** @inheritdoc */
    setBorderLeft(width: number, style: BorderStyle, color: Color): void;
    /** @inheritdoc */
    getBorderLeft(): Border | undefined;
    /** @inheritdoc */
    removeBorderLeft(): void;
    /** @inheritdoc */
    setBorderRight(width: number, style: BorderStyle, color: Color): void;
    /** @inheritdoc */
    getBorderRight(): Border | undefined;
    /** @inheritdoc */
    removeBorderRight(): void;
    /** @inheritdoc */
    setBorderTop(width: number, style: BorderStyle, color: Color): void;
    /** @inheritdoc */
    getBorderTop(): Border | undefined;
    /** @inheritdoc */
    removeBorderTop(): void;
    /** @inheritdoc */
    setHorizontalAlignment(horizontalAlignment: HorizontalAlignment): void;
    /** @inheritdoc */
    getHorizontalAlignment(): HorizontalAlignment;
    /** @inheritdoc */
    setHorizontalAlignmentLastLine(horizontalAlignment: HorizontalAlignmentLastLine): void;
    /** @inheritdoc */
    getHorizontalAlignmentLastLine(): HorizontalAlignmentLastLine;
    /** @inheritdoc */
    setKeepTogether(keepTogether?: boolean): void;
    /** @inheritdoc */
    getKeepTogether(): boolean;
    /** @inheritdoc */
    setKeepWithNext(keepWithNext?: boolean): void;
    /** @inheritdoc */
    getKeepWithNext(): boolean;
    /** @inheritdoc */
    setLineHeight(lineHeight: number | string | undefined): void;
    /** @inheritdoc */
    getLineHeight(): number | string | undefined;
    /** @inheritdoc */
    setLineHeightAtLeast(minimumLineHeight: number | undefined): void;
    /** @inheritdoc */
    getLineHeightAtLeast(): number | undefined;
    /** @inheritdoc */
    setLineSpacing(lineSpacing: number | undefined): void;
    /** @inheritdoc */
    getLineSpacing(): number | undefined;
    /** @inheritdoc */
    setMarginBottom(margin: number): void;
    /** @inheritdoc */
    getMarginBottom(): number;
    /** @inheritdoc */
    setMarginLeft(margin: number): void;
    /** @inheritdoc */
    getMarginLeft(): number;
    /** @inheritdoc */
    setMarginRight(margin: number): void;
    /** @inheritdoc */
    getMarginRight(): number;
    /** @inheritdoc */
    setMarginTop(margin: number): void;
    /** @inheritdoc */
    getMarginTop(): number;
    /** @inheritdoc */
    setMargin(marginLeft: number, marginRight: number, marginTop: number, marginBottom: number): void;
    /** @inheritdoc */
    setOrphans(orphans: number | undefined): void;
    /** @inheritdoc */
    getOrphans(): number | undefined;
    /** @inheritdoc */
    setPaddingBottom(padding: number): void;
    /** @inheritdoc */
    getPaddingBottom(): number;
    /** @inheritdoc */
    setPaddingLeft(padding: number): void;
    /** @inheritdoc */
    getPaddingLeft(): number;
    /** @inheritdoc */
    setPaddingRight(padding: number): void;
    /** @inheritdoc */
    getPaddingRight(): number;
    /** @inheritdoc */
    setPaddingTop(padding: number): void;
    /** @inheritdoc */
    getPaddingTop(): number;
    /** @inheritdoc */
    setPadding(paddingLeft: number, paddingRight: number, paddingTop: number, paddingBottom: number): void;
    /** @inheritdoc */
    setPageBreak(pageBreak: PageBreak): void;
    /** @inheritdoc */
    getPageBreak(): PageBreak;
    /** @inheritdoc */
    setTextIndent(textIndent: number): void;
    /** @inheritdoc */
    getTextIndent(): number;
    /** @inheritdoc */
    setVerticalAlignment(verticalAlignment: VerticalAlignment): void;
    /** @inheritdoc */
    getVerticalAlignment(): VerticalAlignment;
    /** @inheritdoc */
    setWidows(widows: number | undefined): void;
    /** @inheritdoc */
    getWidows(): number | undefined;
    /** @inheritdoc */
    addTabStop(position: number, type: TabStopType): TabStop | undefined;
    /** @inheritDoc */
    addTabStop(tabStop: TabStop): TabStop | undefined;
    /** @inheritdoc */
    getTabStops(): TabStop[];
    /** @inheritdoc */
    clearTabStops(): void;
    /**
     * Sorts the tab stops by their position ascending.
     */
    private sortTabStops;
}
