"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OdfTextElement = void 0;
const OdfElement_1 = require("../OdfElement");
/**
 * This class represents text in a paragraph.
 *
 * @since 0.3.0
 * @private
 */
class OdfTextElement extends OdfElement_1.OdfElement {
    /**
     * Creates a text
     *
     * @param {string} text The text content
     * @since 0.3.0
     */
    constructor(text) {
        super();
        this.text = text;
    }
    /**
     * Sets the new text content.
     *
     * @param {string} text The new text content
     * @since 0.3.0
     */
    setText(text) {
        this.text = text;
    }
    /**
     * Returns the text content.
     *
     * @returns {string} The text content
     * @since 0.3.0
     */
    getText() {
        return this.text;
    }
}
exports.OdfTextElement = OdfTextElement;
