import { IStyles } from '../../api/office';
/**
 * Transforms a {@link StyleManager} object into ODF conform XML
 *
 * NOTE: The properties are set in the order of their appearance in the Realx NG schema.
 *
 * @since 0.9.0
 */
export declare class StylesWriter {
    /**
     * Transforms the given {@link FontFaceDeclarations} into Open Document Format.
     *
     * @param {IStyles} styles The styles to serialize
     * @param {Document} document The XML document
     * @param {Element} parent The parent node in the DOM
     * @since 0.7.0
     */
    write(styles: IStyles, document: Document, root: Element): void;
    private visitStyle;
    private createStyleElement;
    private setClass;
    private setFamily;
    private setName;
}
